#include <stdio.h>
#include "messages.h"
#include "example_params.h"
#include "sv_circuit.h"
#include "sv_lib.h"
#include "sv_module.h"

//---------------------------------------------------------------------------
int main(int argc, char* argv[])
{
  Progress("Reading command line parameters");
  if (example_process_params(argc, argv))
  {
    Progress("Creating library object");
    Lib* lib = new Lib(NULL);
    Progress("Creating circuit object");
    Circuit* circuit = new Circuit(TAG_UNDEFINED, NULL, NULL, lib);
    Module* module_top = NULL;
    // read library predefined modules
    Progress("Reading library modules");
    lib->readModules(_example_include_file_names);
    // calc hierarchy of the circuit
    Progress("Calculating library modules hierarchy");
    lib->calcHierarchy();
    // read circuit
    Progress("Reading input files");
    circuit->readModules(_example_input_file_names);
    // calc hierarchy of the circuit
    Progress("Calculating circuit hierarchy");
    circuit->calcHierarchy();
    // find the topmost module
    Progress("Calculating the topmost module");
    module_top = circuit->calcModuleTop();
    
    // YOUR CODE GOES HERE
    
    // write the resultunt circuit into the output file
    Progress("Writing output file");
    circuit->writeModules(_example_output_file_name);
    // clean up
    Progress("Cleaning up circuit object");
    delete circuit;
    Progress("Cleaning up library object");
    delete lib;
  }
  Progress("Cleaning up command line parameters");
  example_clear_params();
  Progress("Done");
  return 1;
}

