#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "example_msgs.h"

const char* _example_fmt_help =
  "This is a simple example of using a Structural Verilog parser.\n"
  "Usage: %s [OPTIONS] [INPUT_FILE_NAMES]\n"
  "  -o,  --output OUTPUT_FILE_NAME  netlist output file [STDOUT]\n"
  "  -i,  --include INC_FILE_NAMES   coma-separated library input files [STDIN]\n"
  "  -h,  --help                     print this help only\n"
  "  -v,  --version                  print version only\n";
const char* _example_fmt_version =
  "Version %d.%d\n"
  "Last changed at %s\n"
  "Created by Danil Sokolov (E-mail: danil.sokolov@ncl.ac.uk, ICQ#: 30193190)\n"
  "Copyright (c) 2003, University of Newcastle, Newcastle upon Tyne, UK\n";

const int _example_version_major = 1;
const int _example_version_minor = 0;
const char* _example_version_date = "29 August 2005";

//---------------------------------------------------------------------------
char* example_get_help(char* name)
{
  int len = strlen (_example_fmt_help) + 2 * strlen (name) + 1;
  char* help = new char [len];
  sprintf (help, _example_fmt_help, name, name);
  return help;
}

//---------------------------------------------------------------------------
char* example_get_version (char* name)
{
  int len = strlen (_example_fmt_version) + strlen (_example_version_date) + 1;
  char* version = new char [len];
  sprintf (version, _example_fmt_version, _example_version_major,
    _example_version_minor, _example_version_date);
  return version;
}
