#include "le_graph.h"


//constructor
Graph::Graph()
{
	tmpTrace = NULL;
 	traces = NULL;
}




Graph::Graph(const Graph &rhs) :STG(rhs)
{

}



//destructor
Graph::~Graph()
{
// 	if (tmpTrace != NULL)
// 		delete tmpTrace;

}





void Graph::extractTraces(darray<Trace*> *tracesIn)
{
	traces = tracesIn;

	for (int i=0; i<this->transitions->num; i++)
		if (this->transitions->arr[i]->getSignal()->getType() == Signal::TYPE_INPUT)
			for (int j=0; j<this->transitions->arr[i]->postset->num; j++)
			{
				tmpTrace = new TraceElement;
				tmpTrace->set(this->transitions->arr[i]);

				traverseForward(this->transitions->arr[i]->postset->arr[j]);

				delete tmpTrace;
			}
}









//####################################################################################
//overload operators
//####################################################################################









///////////////////////////////////////////////////////////////////////////////////////
//	private methods
///////////////////////////////////////////////////////////////////////////////////////




void Graph::traverseForward(Transition *t)
{
	if (t->getSignal()->getType() == Signal::TYPE_INPUT) //add trace to array
  {
		traces->add(new Trace(tmpTrace));
		return;
	}

	for (int i=0; i<t->postset->num; i++)
	{
		tmpTrace->set(t);
		traverseForward(t->postset->arr[i]);
		tmpTrace->getTransitions()->remove(t, 0);
	}
}




void Graph::traverseForward(Place *p)
{
	bool isFreeChoice = isPlaceFreeChoice(p);

	for (int i=0; i<p->postset->num; i++)
		if (isFreeChoice)
		{
			if (i == 0)
				traverseForward(p->postset->arr[i]);
		}
		else
			traverseForward(p->postset->arr[i]);
}




bool Graph::isPlaceFreeChoice(Place *p)
{
	for (int i=0; i<p->postset->num; i++)
		if (p->postset->arr[i]->getSignal()->getType() != Signal::TYPE_INPUT) //non-input signal
			return false;

	return true;
}





