#include "le_leffort.h"



//constructor
LEffort::LEffort()
{
	myLib = NULL;
	myCircuit = NULL;
	myModule = NULL;
	myGraph = NULL;

	traces = NULL;


	myTrace = NULL;
	myPath = NULL;
}




LEffort::LEffort(const LEffort &rhs)
{
	
}



//destructor
LEffort::~LEffort()
{
	// 	if (traces != NULL)
// 	{	
// 		for (int i=0; i<traces->num; i++)
// 			delete traces->arr[i];
// 		delete []traces;
// 	}

	if (myCircuit != NULL)
		delete myCircuit;

	if (myLib != NULL)
		delete myLib;

	if (myGraph != NULL)
		delete myGraph;
}





void LEffort::readVerilog(char *libName, char *circuitName)
{
	myLib = new Lib(NULL);
	myLib->readModules(libName);
	myLib->calcHierarchy();

	myCircuit = new Circuit(TAG_UNDEFINED, NULL, NULL, myLib);
	myCircuit->readModules(circuitName);
	myCircuit->calcHierarchy();

	myCircuit->writeModules("-");	

	myModule = myCircuit->calcModuleTop();


// 	for (int i=0; i<myModule->ports->num; i++)
// 	{
// 		if (!myModule->ports->arr[i]->testTag(TAG_OBJ_HIDDEN))
// 		{
// 			cout << myModule->ports->arr[i]->getName() << ": ";
// 			for (int j=0; j<myModule->ports->arr[i]->nets->num; j++)
// 				cout << myModule->ports->arr[i]->nets->arr[j]->getName() << endl;
// 			cout << endl;
// 		}
// 	}
}




void LEffort::readSTG(char *stgName)
{
	myGraph = new Graph;
	myGraph->readASTG(stgName);
	//myGraph->writeASTG("-");
}



void LEffort::extractTraces()
{
	traces = new darray<Trace*>();
	myGraph->extractTraces(traces);
	setConnectionTraces();
	
	cout << endl << "traces: " << endl;
	for (int i=0; i<traces->num; i++)
		cout << *(traces->arr[i]) << endl;

	extractPaths();
}





void LEffort::extractPaths()
{
	for (int i=0; i<traces->num; i++)
	{
		myTrace = traces->arr[i];
		if (myTrace->getTrace()->getConnections()->num >= 2)
			extractPath(myTrace->getTrace()->getConnections()->arr[0], myTrace->getTrace()->getConnections()->arr[1], 2);
	}
}





//####################################################################################
//overload operators
//####################################################################################

ostream& operator << (ostream &os, const LEffort &t)
{
	

	return os;
}









///////////////////////////////////////////////////////////////////////////////////////
//	private methods
///////////////////////////////////////////////////////////////////////////////////////




void LEffort::setConnectionTraces()
{
	for (int i=0; i<traces->num; i++)
		for (int j=0; j<traces->arr[i]->getTrace()->getTransitions()->num; j++)
		 	traces->arr[i]->set(findConnection(traces->arr[i]->getTrace()->getTransitions()->arr[j]->getSignal()->getName()));
}



Connection * LEffort::findConnection(char *name)
{
	for (int i=0; i<myModule->instances->num; i++)
		for (int j=0; j<myModule->instances->arr[i]->connections->num; j++)
			if (strcmp(name, myModule->instances->arr[i]->connections->arr[j]->genFullName()) == 0)
				return myModule->instances->arr[i]->connections->arr[j];
	return NULL;
}







void LEffort::extractPath(Connection *currentConnection, Connection *nextConnection, int pos)
{
	for (int i=0; i<currentConnection->nets->num; i++)
		if (currentConnection->nets->arr[i]->getContainer()->testTag(TAG_PORT_OUTPUT))
		{
			if (strcmp(currentConnection->nets->arr[i]->getName(), nextConnection->nets->arr[i]->getName()) == 0) 
			{	
				if (isTracesEnd(currentConnection->nets->arr[i]))
				{
					
					myPath->set(currentConnection, NULL); cout << "set path: " << *myPath << endl;
					myTrace->set(myPath);
					myPath->remove(currentConnection, NULL);
				
					return;
				}
	
				nextConnection = myTrace->getTrace()->getConnections()->arr[pos]; //set next output connection
				pos++;
				
				for (int j=0; j<currentConnection->nets->arr[i]->postset->num; j++)
				{
					cout << "path: " << currentConnection->genFullName() << " " << currentConnection->nets->arr[i]->postset->arr[j]->genFullName() << endl;
					myPath->set(currentConnection, currentConnection->nets->arr[i]->postset->arr[j]);
					extractPath(getInstancesOutput(currentConnection->nets->arr[i]->postset->arr[j]), nextConnection, pos);
					myPath->remove(currentConnection, currentConnection->nets->arr[i]->postset->arr[j]);
				}	
			}
		}
		else //current net is non-output, go to next instance
		{
			if (currentConnection->nets->arr[i]->postset == NULL)
				return;
	
			for (int j=0; j<currentConnection->nets->arr[i]->postset->num; j++)
			{
				cout << "path: " << currentConnection->genFullName() << " " << currentConnection->nets->arr[i]->postset->arr[j]->genFullName() << endl;
				myPath->set(currentConnection, currentConnection->nets->arr[i]->postset->arr[j]);
				extractPath(getInstancesOutput(currentConnection->nets->arr[i]->postset->arr[j]), nextConnection, pos);
				myPath->remove(currentConnection, currentConnection->nets->arr[i]->postset->arr[j]);
			}	
		}
}





bool LEffort::isTracesEnd(Net *myNet)
{
	Connection *terminal = myTrace->getTrace()->getConnections()->arr[myTrace->getTrace()->getConnections()->num-1];
	for (int i=0; i<terminal->nets->num; i++)
		if (strcmp(myNet->getName(), terminal->nets->arr[i]->getName()) == 0)
			return true;
	return false;
}




Connection * LEffort::getInstancesOutput(Instance *instance)
{
	for (int i=instance->connections->num-1; i>=0; i--)
		for (int j=0; j<instance->connections->arr[i]->nets->num; j++)
			if (instance->connections->arr[i]->nets->arr[j]->getContainer()->testTag(TAG_PORT_INPUT))
				return instance->connections->arr[i];
}






