#ifndef LEFFORT_H
#define LEFFORT_H


//#include <iostream.h>
//#include "darray.h"

#include "sv_lib.h"
#include "sv_circuit.h"
#include "le_graph.h"
#include "le_trace.h"



class LEffort
{
	public:
		//constructor & destructor
		LEffort();
		LEffort(const LEffort &);
		~LEffort();

		
		//	public accessor methods
		//==========================

		
		
    //	public methods
    //==================

		void readVerilog(char *, char *);	
		void readSTG(char *);
		void readLEparameters(char *);


		void extractTraces();	
		void extractPaths();
		


    //overload operators
		friend ostream& operator << (ostream &, const LEffort &);


		//	public member variables
		//===========================
		

		

	private:

		//	private methods
		//===================

		void setConnectionTraces();
		Connection * findConnection(char *);

		void extractPath(Connection *, Connection *, int);
		bool isTracesEnd(Net *);
		Connection * getInstancesOutput(Instance *);

		
    //	private member variables
		//===========================

		Lib *myLib;
		Circuit *myCircuit;
		Module *myModule;
		Graph *myGraph;

		darray<Trace*> * traces;
		darray<Path*> *paths;

		Trace *myTrace;
		Path *myPath;
    
};

#endif

