#ifndef LEPARAMETER_H
#define LEPARAMETER_H


//#include "darray.h"
//#include <iostream.h>


//parameters

#define SEPERATOR       	"_"
#define REF_INVERTER    	"IN1"
#define REF_INVERTER_PIN 	"A"

//input LE parameter
#define D1_PRAC_RISE      "d1_rise"
#define D2_PRAC_RISE      "d2_rise"
#define D1_PRAC_FALL      "d1_fall"
#define D2_PRAC_FALL      "d2_fall"

#define C_PRAC_IN      		"c_in_prac"
#define C_THEO_IN      		"c_in_theo"

//logical efforts
#define G_PRAC_RISE    		"g_rise"
#define G_PRAC_FALL    		"g_fall"
#define G_THEO    				"g"

//parasitics
#define P_PRAC_RISE    		"p_rise"
#define P_PRAC_FALL    		"p_fall"
#define P_THEO    				"p"



//output capacitance corresponding to logical effort parameters
const double C1_PRAC_OUT = 0.015;		//0.015pF
const double C2_PRAC_OUT = 0.15;	 	//0.15pF

//slope parameters

//tau = alpha*slope_in + beta
const double ALPHA_RISE = 0.048;
const double ALPHA_FALL = 0.01;
const double BETA_RISE = 0.033;
const double BETA_FALL = 0.028;

//slope_out = a*h + b*slope_in + c
const double A_RISE = 0.087;
const double A_FALL = 0.057;
const double B_RISE = 0.221;
const double B_FALL = 0.25;
const double C_RISE = 0.062;
const double C_FALL = 0.02;

//initial slope
const double SLOPE_INITIAL = 0.3;



// extern void setReferenceInverterParameters(Module *);
// extern void setParameters();
// 
// 
// extern double tau_rise;
// extern double c_in_prac_inv;;
// extern double c_in_theo_inv;

#endif

