#include "le_traceElement.h"


//constructor
TraceElement::TraceElement()
{
	transitions = NULL;
	connections = NULL;
}




TraceElement::TraceElement(const TraceElement &rhs)
{
	if (rhs.transitions != NULL)
	{
		transitions = new darray<Transition*>(rhs.transitions->num);
		for (int i=0; i<rhs.transitions->num; i++)
			transitions->add(rhs.transitions->arr[i]);

	}
	else
		transitions = NULL;

	if (rhs.connections != NULL)
	{
		connections = new darray<Connection*>(rhs.connections->num);
		for (int i=0; i<rhs.connections->num; i++)
			connections->add(rhs.connections->arr[i]);

	}
	else
		connections = NULL;
}



//destructor
TraceElement::~TraceElement()
{
	// 	if (transitions != NULL)
// 	{
// 		for (int i=0; i<transitions->num; i++)
// 			delete transitions->arr[i];
// 		delete []transitions;
// 	}
// 
}





void TraceElement::set(Transition *t)
{
	if (transitions == NULL)
		transitions = new darray<Transition*>();

	transitions->add(t);
}




void TraceElement::set(Connection *c)
{
	if (c == NULL)
		return;

	if (connections == NULL)
		connections = new darray<Connection*>();

	connections->add(c);
}








//####################################################################################
//overload operators
//####################################################################################

ostream& operator << (ostream &os, const TraceElement &t)
{
	if (t.getTransitions() != NULL)
	{
		for (int i=0; i<t.getTransitions()->num; i++)
		{
			cout << t.getTransitions()->arr[i]->getName();
			if (i < (t.getTransitions()->num-1))
				cout << ", ";
		}
		cout << endl;
	}

	if (t.getConnections() != NULL)
	{
		for (int i=0; i<t.getConnections()->num; i++)
		{
			cout << t.getConnections()->arr[i]->genFullName();
			if (i < (t.getConnections()->num-1))
				cout << ", ";
		}
		cout << endl;
	}
	
	return os;
}








///////////////////////////////////////////////////////////////////////////////////////
//	private methods
///////////////////////////////////////////////////////////////////////////////////////






