// Verilog model for a2d_1 
// Change to negative logic & use  complex gate in ams.v (corresponding verilog library) 
// Set/Reset: Set Ar
// Estimated area = 128.00

module a2d_1_net (
    set,
    start,
    Lam,
    Laf,
    Ad,
    ready,
    Lr,
    Ar
);

input set;
input start;
input Lam;
input Laf;
input Ad;

output ready;
output Lr;
output Ar;


// Functions not mapped into library gates:
// ----------------------------------------

// Equation: ready = Laf
BU1 I1 (Laf, ready);

// Equation: _1_ = Ar (Ad start + Laf)
AN32 I2 (Ar, Ad, start, Ar, Laf, n1);
IN1 I3 (n1, _1_);

// Equation: Lr = start Laf + _1_
AN21 I4 (start, Laf, _1_, nLr);
IN1 I5 (nLr, Lr);

// Equation: Ar = Lam' Laf' (Ar + Ad')
ON211 I6 (Ar, Ad_, Lam_, Laf_, Ar1);
NA2 I7 (Ar1, set, Ar);

IN1 I8 (Lam, Lam_);
IN1 I9 (Laf, Laf_);
IN1 I10 (Ad, Ad_);

// signal values at the initial state:
//     !start !Lam !Laf Ad !ready !_1_ !Lr Ar
endmodule
