// Verilog model for a2d_10 
// Change to negative logic on the purpose of saved area and increased speed
// Use gates in ams.v (corresponding verilog library) including complex gates
// Set/Reset: Set [3], Reset csc0

module a2d_10_net (
    set,
    start,
    Lam,
    Laf,
    Ad,
    ready,
    Lr,
    Ar
);

input set;
input start;
input Lam;
input Laf;
input Ad;

output ready;
output Lr;
output Ar;


// Functions not mapped into library gates:
// ----------------------------------------

// Inverted inputs
IN1 I1 (map0, nmap0);
IN1 I2 (Ad, nAd);
IN1 I3 (Lam, nLam);
IN1 I4 (Laf, nLaf);

// Equation: ready = ready (start + Laf) + csc0
AN221 I5 (ready, start, ready, Laf, csc0, nready);
IN1 I6 (nready, ready);

// Equation: _1_ = csc0' ready' start map0'
NA4 I7 (ncsc0, nready, start, nmap0, n1);
IN1 I8 (n1, _1_);

// Equation: Lr = Laf map0' + _1_
AN21 I9 (Laf, nmap0, _1_, nLr);
IN1 I10 (nLr, Lr);

// Equation: _3_ = Lam' Laf' (Ar + Ad')
ON211 I11 (Ar, nAd, nLam, nLaf, n3);
NA2 I12 (set, n3, _3_);

// Equation: Ar = Laf csc0' ready' + _3_
AN31 I13 (Laf, ncsc0, nready, _3_, nAr);
IN1 I14 (nAr, Ar);

// Equation: csc0 = ready' (csc0 + Laf)
ON21 I15 (csc0, Laf, nready, ncsc0);
NO2 I16 (reset, ncsc0, csc0);

// Equation: map0 = Ar' + Ad'
NA2 I17 (Ar, Ad, map0);

IN1 I18 (set, reset);
// signal values at the initial state:
//     !start !Lam !Laf Ad !ready !_1_ !Lr _3_ Ar !csc0 !map0
endmodule
