// Verilog model for a2d_2 
// Change to negative logic on the purpose of saved area and increased speed
// Use gates in ams.v (corresponding verilog library) including complex gates
// Set/Reset: Set Ar
// Estimated area = 152.00

module a2d_2_net (
    set,
    start,
    Lam,
    Laf,
    Ad,
    ready,
    Lr,
    Ar
);

input set;
input start;
input Lam;
input Laf;
input Ad;

output ready;
output Lr;
output Ar;


// Functions not mapped into library gates:
// ----------------------------------------

// Equation: ready = start ready + Laf
AN21 I1 (start, ready, Laf, nready);
IN1 I2 (nready, ready);

// Equation: _1_ = Ad start ready' Ar
NA4 I3 (Ad, start, nready, Ar, n1);
IN1 I4 (n1, _1_);

// Equation: Lr = Laf (Ar + ready') + _1_
AN221 I5 (Laf, Ar, Laf, nready, _1_, nLr);
IN1 I6 (nLr, Lr);

// Equation: Ar = Lam' Laf' (Ar + Ad'), including Set Ar
//IN1 (Ar, nAr);
//AN211 (nAr, Ad, Lam, Laf, Ar1);
//NO2 (Ar1, set, Ar2);
//IN1 (Ar2, Ar);
// Equation: Ar = Lam' Laf' (Ar + Ad')
ON211 I7 (Ar, Ad_, Lam_, Laf_, Ar1);
NA2 I8 (Ar1, set, Ar);

IN1 I11 (Lam, Lam_);
IN1 I9 (Laf, Laf_);
IN1 I10 (Ad, Ad_);

// signal values at the initial state:
//     !start !Lam !Laf Ad !ready !_1_ !Lr Ar
endmodule
