// Verilog model for a2d_3 
// Change to negative logic in order to save area and increase speed 
// Use gates in ams.v (corresponding verilog library) including complex gates
// Set/Reset :  Set Ar

module a2d_3_net (
    set,
    start,
    Lam,
    Laf,
    Ad,
    ready,
    Lr,
    Ar
);

input set;
input start;
input Lam;
input Laf;
input Ad;

output ready;
output Lr;
output Ar;


// Functions not mapped into library gates:
// ----------------------------------------

// Equation: ready = start ready + Laf
AN21 I1 (start, ready, Laf, nready);
IN1 I2 (nready, ready);

// Equation: _1_ = start ready' Ad Ar
NA4 I3 (start, nready, Ad, Ar, n1);
IN1 I4 (n1, _1_);

// Equation: Lr = Ar Laf + _1_
AN21 I5 (Ar, Laf, _1_, nLr);
IN1 I6 (nLr, Lr);

// Equation: _3_ = Lam' Laf' (Ar + Ad')
IN1 I7 (Ar, nAr);
AN211 I8 (nAr, Ad, Lam, Laf, _3_);

// Equation: Ar = ready' Laf + _3_
AN21 I9 (nready, Laf, _3_, Ar1);
// Set Ar
NA2 I10 (Ar1, set, Ar);

// signal values at the initial state:
//     !start !Lam !Laf Ad !ready !_1_ !Lr _3_ Ar
endmodule
