// Verilog model for a2d_4 
// Change to negative logic on the purpose of saved area and increased speed
// Use gates in ams.v (corresponding verilog library) including complex gates
// Set/Reset: Set [2]


module a2d_4_net (
    set,
    start,
    Lam,
    Laf,
    Ad,
    ready,
    Lr,
    Ar
);

input set;
input start;
input Lam;
input Laf;
input Ad;

output ready;
output Lr;
output Ar;


// Functions not mapped into library gates:
// ----------------------------------------

// Equation: ready = Laf
BU1 I1 (Laf, ready);

// Equation: Lr = Ad Ar (Laf + start)
ON211 I2 (Laf, start, Ad, Ar, nLr);
IN1 I3 (nLr, Lr);

// Equation: _2_ = Lam' Laf' (Ar + Ad')
IN1 I4 (Ad, nAd);
IN1 I5 (Lam, nLam);
IN1 I6 (Laf, nLaf);
ON211 I7 (Ar, nAd, nLam, nLaf, Ar1);
NA2 I8 (set, Ar1, _2_);

// Equation: Ar = start Laf + _2_
AN21 I9 (start, Laf, _2_, nAr);
IN1 I10 (nAr, Ar);

// signal values at the initial state:
//     !start !Lam !Laf Ad !ready !Lr _2_ Ar
endmodule
