// Verilog model for a2d_6 
// Change to negative logic on the purpose of saved area and increased speed
// Use gates in ams.v (corresponding verilog library) including complex gates
// Set/Reset: Set [3]

module a2d_6_net (
    set,
    start,
    Lam,
    Laf,
    Ad,
    ready,
    Lr,
    Ar
);

input set;
input start;
input Lam;
input Laf;
input Ad;

output ready;
output Lr;
output Ar;


// Functions not mapped into library gates:
// ----------------------------------------

// Inverted inputs
IN1 I1 (Ad, nAd);
IN1 I2 (Lam, nLam);
IN1 I3 (Laf, nLaf);

// Equation: ready = csc0
BU1 I4 (csc0, ready);

// Equation: _1_ = start csc0' Ar Ad
NA4 I5 (start, ncsc0, Ar, Ad, n1);
IN1 I6 (n1, _1_);

// Equation: Lr = Laf Ar + _1_
AN21 I7 (Laf, Ar, _1_, nLr);
IN1 I8 (nLr, Lr);

// Equation: _3_ = Lam' Laf' (Ad' + Ar)
ON211 I9 (Ar, nAd, nLam, nLaf, n3);
// Set [3]
NA2 I10 (set, n3, _3_);

// Equation: Ar = csc0' Laf + _3_
AN21 I11 (ncsc0, Laf, _3_, nAr);
IN1 I12 (nAr, Ar);

// Equation: csc0 = start csc0 + Laf
AN21 I13 (start, csc0, Laf, ncsc0);
IN1 I14 (ncsc0, csc0);

// signal values at the initial state:
//     !start !Lam !Laf Ad !ready !_1_ !Lr _3_ Ar !csc0
endmodule
