// Verilog model for a2d_7 
// Change to negative logic on the purpose of saved area and increased speed
// Use gates in ams.v (corresponding verilog library) including complex gates
// Set/Reset: Set Ar

module a2d_7_net (
    set,
    start,
    Lam,
    Laf,
    Ad,
    ready,
    Lr,
    Ar
);

input set;
input start;
input Lam;
input Laf;
input Ad;

output ready;
output Lr;
output Ar;


// Functions not mapped into library gates:
// ----------------------------------------
//Inverted inputs
IN1 I1 (Ad, nAd);

// Equation: ready = Laf + csc0
NO2 I2 (Laf, csc0, nready);
IN1 I3 (nready, ready);

// Equation: _1_ = start csc0' Ad Ar
NA4 I4 (start, ncsc0, Ad, Ar, n1);
IN1 I5 (n1, _1_);

// Equation: Lr = Ar Laf + _1_
AN21 I6 (Ar, Laf, _1_, nLr);
IN1 I7 (nLr, Lr);

// Equation: _3_ = csc0 Laf + Lam
AN21 I8 (csc0, Laf, Lam, n3);
IN1 I9 (n3, _3_);

// Equation: Ar = _3_' (Ar + Ad')
ON21 I10 (Ar, nAd, n3, Ar1);
// Set Ar
NA2 I11 (set, Ar1, Ar);

// Equation: csc0 = start csc0 + Laf
AN21 I12 (start, csc0, Laf, ncsc0);
IN1 I13 (ncsc0, csc0);

// signal values at the initial state:
//     !start !Lam !Laf Ad !ready !_1_ !Lr !_3_ Ar !csc0
endmodule
