// Verilog model for a2d_8 
// Change to negative logic on the purpose of saved area and increased speed
// Use gates in ams.v (corresponding verilog library) including complex gates
// Set/Reset: Set Ar

module a2d_8_net (
    set,
    start,
    Lam,
    Laf,
    Ad,
    ready,
    Lr,
    Ar
);

input set;
input start;
input Lam;
input Laf;
input Ad;

output ready;
output Lr;
output Ar;


// Functions not mapped into library gates:
// ----------------------------------------

// Inverted inputs
IN1 I1 (Ad, nAd);
IN1 I2 (Lam, nLam);
IN1 I3 (Laf, nLaf);

// Equation: ready = Laf + csc0
NO2 I5 (Laf, csc0, nready);
IN1 I6 (nready, ready);

// Equation: _1_ = start csc0' Ar Ad
NA4 I7 (start, ncsc0, Ar, Ad, n1);
IN1 I8 (n1, _1_);

// Equation: Lr = csc0' Laf + _1_
AN21 I9 (ncsc0, Laf, _1_, nLr);
IN1 I10 (nLr, Lr);

// Equation: Ar = Lam' Laf' (Ad' + Ar)
ON211 I11 (Ar, nAd, nLam, nLaf, nAr);
// Set Ar
NA2 I12 (set, nAr, Ar);

// Equation: csc0 = Laf Ar' + start csc0
AN22 I13 (Laf, nAr, start, csc0, ncsc0);
IN1 I14 (ncsc0, csc0);

// signal values at the initial state:
//     !start !Lam !Laf Ad !ready !_1_ !Lr Ar !csc0
endmodule
