// Verilog model for a2d_9 
// Change to negative logic on the purpose of saved area and increased speed
// Use gates in ams.v (corresponding verilog library) including complex gates
// Set/Reset: Set [3]

module a2d_9_net (
    set,
    start,
    Lam,
    Laf,
    Ad,
    ready,
    Lr,
    Ar
);

input set;
input start;
input Lam;
input Laf;
input Ad;

output ready;
output Lr;
output Ar;


// Functions not mapped into library gates:
// ----------------------------------------

// Inverted inputs
IN1 I1 (Ad, nAd);
IN1 I2 (Lam, nLam);
IN1 I3 (Laf, nLaf);

// Equation: ready = Laf start' + csc0
AN21 I4 (Laf, nstart, csc0, nready);
IN1 I5 (nready, ready);

// Equation: _1_ = Ad Ar csc0' start
NA4 I6 (Ad, Ar, ncsc0, start, n1);
IN1 I7 (n1, _1_);

// Equation: Lr = Ar Laf + _1_
AN21 I8 (Ar, Laf, _1_, nLr);
IN1 I9 (nLr, Lr);

// Equation: _3_ = Lam' Laf' (Ar + Ad')
ON211 I10 (Ar, nAd, nLam, nLaf, n3);
NA2 I11 (set, n3, _3_);

// Equation: Ar = Laf csc0' start + _3_
AN31 I12 (Laf, ncsc0, start, _3_, nAr);
IN1 I13 (nAr, Ar);

// Equation: csc0 = start (csc0 + Laf)
ON21 I14 (csc0, Laf, start, ncsc0);
IN1 I15 (ncsc0, csc0);

IN1 I16 (start, nstart);

// signal values at the initial state:
//     !start !Lam !Laf Ad !ready !_1_ !Lr _3_ Ar !csc0
endmodule
