// Verilog model for . 
// Change to negative logic on the purpose of saved area and increased speed
// Use gates in ams.v (corresponding verilog library) including complex gates
// No Set/Reset pins required

module vme_read_net (
    DSr,
    LDTACK,
    D,
    LDS,
    DTACK
);

input DSr;
input LDTACK;

output D;
output LDS;
output DTACK;


// Functions not mapped into library gates:
// ----------------------------------------

// Inverted inputs
IN1 I1 (DSr, nDSr);
IN1 I2 (LDTACK, nLDTACK);
IN1 I_2 (ff0, nff0);
IN1 I_3 (ff1, nff1);

// Equation: D = LDTACK ff1
NA2 I3 (LDTACK, ff1, D_n);
IN1 I4 (D_n, D);

// Equation: LDS = D + ff0'
NO2 I5 (D, nff0, LDS_n);
IN1 I6 (LDS_n, LDS);

// Equation: DTACK = D
BU1 I7 (D, DTACK);

// Equation: ff0 = DSr' + ff1'
NA2 I8 (DSr, ff1, ff0);

// Equation: ff1 = ff0' + LDTACK'
NA2 I10 (ff0, LDTACK, ff1);

// signal values at the initial state:
//     !DSr !LDTACK !D !LDS !DTACK ff0 ff1
endmodule
