// Verilog model for vme_read_sol_0 
// Change to negative logic on the purpose of saved area and increased speed
// Use gates in ams.v (corresponding verilog library) including complex gates
// No Set/Reset pins required

module vme_read_sol_0_net (
    DSr,
    LDTACK,
    D,
    LDS,
    DTACK
);

input DSr;
input LDTACK;

output D;
output LDS;
output DTACK;


// Functions not mapped into library gates:
// ----------------------------------------

// Inverted inputs
IN1 I1 (DSr, nDSr);
IN1 I2 (LDTACK, nLDTACK);

// Equation: D = LDTACK DSr LDS
NA3 I3 (LDTACK, DSr, LDS, nD);
IN1 I4 (nD, D);

// Equation: LDS = DSr (LDS + LDTACK') + D
AN221 I5 (DSr, LDS, DSr, nLDTACK, D, nLDS);
IN1 I6 (nLDS, LDS);

// Equation: DTACK = LDS (D + DSr')
ON21 I7 (D, nDSr, LDS, nDTACK);
IN1 I8 (nDTACK, DTACK);

// signal values at the initial state:
//     !DSr !LDTACK !D !LDS !DTACK

// CDA 07/09/05: Left unchanged as no inversion of intermediate values is required
endmodule
