// Verilog model for vme_read_sol_13 
// Change to negative logic on the purpose of saved area and increased speed
// Use gates in ams.v (corresponding verilog library) including complex gates
// Set/Reset: reset(LDS)

module vme_read_sol_13_net (
    reset,
    DSr,
    LDTACK,
    D,
    LDS,
    DTACK
);

input reset;
input DSr;
input LDTACK;

output D;
output LDS;
output DTACK;


// Functions not mapped into library gates:
// ----------------------------------------

// Inverted inputs
IN1 I1 (DSr, nDSr);
IN1 I_0 (LDS, nLDS);
IN1 I_1 (csc0, ncsc0);
IN1 I_2 (_2_, n2);

// Equation: _0_ = LDTACK LDS csc0'
NA3 I2 (LDTACK, LDS, ncsc0, n_0);
IN1 I3 (n_0, _0_);

// Equation: D = DSr D + _0_
AN21 I4 (DSr, D, _0_, D_n);
IN1 I5 (D_n, D);

// Equation: _2_ = LDS' (DSr' + LDTACK) + csc0
AN221 I6 (nLDS, nDSr, nLDS, LDTACK, csc0, n_2);
IN1 I7 (n_2, _2_);

// Equation: DTACK = D
BU1 I8 (D, DTACK);

// Equation: csc0 = LDS csc0 + D
AN21 I9 (LDS, csc0, D, csc0_n);
IN1 I10 (csc0_n, csc0);

// Equation: LDS = D + _2_'
NO2 I11 (D, n2, LDS_n);
NO2 I12 (reset, LDS_n, LDS);

// signal values at the initial state:
//     !DSr !LDTACK !_0_ !D _2_ !DTACK !csc0 !LDS
endmodule
