// Verilog model for vme_read_sol_16 
// Change to negative logic on the purpose of saved area and increased speed
// Use gates in ams.v (corresponding verilog library) including complex gates
// No Set/Reset pins required

module vme_read_sol_16_net (
    DSr,
    LDTACK,
    D,
    LDS,
    DTACK
);

input DSr;
input LDTACK;

output D;
output LDS;
output DTACK;


// Functions not mapped into library gates:
// ----------------------------------------

// Inverted inputs
IN1 I1 (DSr, nDSr);

// Equation: D = LDTACK DSr
NA2 I2 (LDTACK, DSr, D_n);
IN1 I3 (D_n, D);

// Equation: LDS = DSr + D
NO2 I4 (DSr, D, LDS_n);
IN1 I5 (LDS_n, LDS);

// Equation: DTACK = LDTACK (DSr' + D)
ON21 I6 (nDSr, D, LDTACK, DTACK_n);
IN1 I7 (DTACK_n, DTACK);

// signal values at the initial state:
//     !DSr !LDTACK !D !LDS !DTACK
endmodule
