// Verilog model for vme_read_sol_2 
// Change to negative logic on the purpose of saved area and increased speed
// Use gates in ams.v (corresponding verilog library) including complex gates
// No Set/Reset pins required

module vme_read_sol_2_net (
    DSr,
    LDTACK,
    D,
    LDS,
    DTACK
);

input DSr;
input LDTACK;

output D;
output LDS;
output DTACK;


// Functions not mapped into library gates:
// ----------------------------------------

// Inverted inputs
IN1 I1 (DSr, nDSr);
IN1 I_2 (csc0, ncsc0);


// Equation: D = LDTACK csc0'
NA2 I2 (LDTACK, ncsc0, D_n);
IN1 I3 (D_n, D);

// Equation: LDS = csc0' + D
NO2 I4 (D, ncsc0, LDS_n);
IN1 I5 (LDS_n, LDS);

// Equation: DTACK = D
BU1 I6 (D, DTACK);

// Equation: csc0 = LDTACK csc0 + DSr'
AN21 I7 (LDTACK, csc0, nDSr, csc0_n);
IN1 I8 (csc0_n, csc0);

// signal values at the initial state:
//     !DSr !LDTACK !D !LDS !DTACK csc0
endmodule
