// Verilog model for vme_read_sol_4 
// Change to negative logic on the purpose of saved area and increased speed
// Use gates in ams.v (corresponding verilog library) including complex gates
// No Set/Reset pins required

module vme_read_sol_4_net (
    DSr,
    LDTACK,
    D,
    LDS,
    DTACK
);

input DSr;
input LDTACK;

output D;
output LDS;
output DTACK;


// Functions not mapped into library gates:
// ----------------------------------------

IN1 I_0 (D, nD);
IN1 I_2 (csc0, ncsc0);

// Equation: D = LDTACK (DSr D + csc0')
AN32 I1 (LDTACK, DSr, D, LDTACK, ncsc0, D_n);
IN1 I2 (D_n, D);

// Equation: LDS = csc0' DSr + D
AN21 I3 (ncsc0, DSr, D, LDS_n);
IN1 I4 (LDS_n, LDS);

// Equation: DTACK = D
BU1 I5 (D, DTACK);

// Equation: csc0 = LDTACK csc0 + D
AN21 I6 (LDTACK, csc0, D, csc0_n);
IN1 I7 (csc0_n, csc0);

// signal values at the initial state:
//     !DSr !LDTACK !D !LDS !DTACK !csc0
endmodule
