#include "le_element.h"


//constructor
Element::Element()
{
	connection = NULL;
	instance = NULL;

	delay_theo = 0.0;
	delay_prac = 0.0;
	delay_slope = 0.0;

	g_theo = 0.0;
	h_theo = 0.0;
	p_theo = 0.0;

	g_prac = 0.0;
	h_prac = 0.0;
	p_prac = 0.0;

	slope = 0.0;
	tau_slope = 0.0;
}


Element::Element(Connection *c, Instance *i)
{
	connection = c;
	instance = i;

	delay_theo = 0.0;
	delay_prac = 0.0;
	delay_slope = 0.0;

	g_theo = 0.0;
	h_theo = 0.0;
	p_theo = 0.0;

	g_prac = 0.0;
	h_prac = 0.0;
	p_prac = 0.0;

	slope = 0.0;
	tau_slope = 0.0;

}



Element::Element(const Element &rhs)
{
	connection = rhs.connection;
	instance = rhs.instance;

	delay_theo = rhs.delay_theo;
	delay_prac = rhs.delay_prac;
	delay_slope = rhs.delay_slope;

	g_theo = rhs.g_theo;
	h_theo = rhs.h_theo;
	p_theo = rhs.p_theo;

	g_prac = rhs.g_prac;
	h_prac = rhs.h_prac;
	p_prac = rhs.p_prac;

	slope = rhs.slope;
	tau_slope = rhs.tau_slope;
}



//destructor
Element::~Element()
{
	
}








//####################################################################################
//overload operators
//####################################################################################

ostream& operator << (ostream &os, const Element &e)
{
	if (e.getConnection() != NULL)
		//cout << e.getConnection()->genFullName();
		cout << e.getConnection()->nets->arr[0]->getName();

	if (e.getInstance() != NULL)
		cout << " -> " << e.getInstance()->getName();

	//cout << "[" << e.getDelayTheo() << "; " << e.getDelayPrac() << "]";

	
	return os;
}








///////////////////////////////////////////////////////////////////////////////////////
//	private methods
///////////////////////////////////////////////////////////////////////////////////////






