#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "le_msgs.h"

const char* _stg_fmt_help =
  "This is a simple stg of using an ASTG parser\n"
  "Usage: %s [OPTIONS] [INPUT_FILE_NAMES]\n"
  "  -o,  --output OUTPUT_FILE_NAME  STG output file [STDOUT]\n"
  "  -h,  --help                     print this help only\n"
  "  -v,  --version                  print version only\n";
const char* _stg_fmt_version =
  "Version %d.%d\n"
  "Last changed at %s\n"
  "Created by Danil Sokolov (E-mail: danil.sokolov@ncl.ac.uk, ICQ#: 30193190)\n"
  "Copyright (c) 2003, University of Newcastle, Newcastle upon Tyne, UK\n";


const char* _sv_fmt_help =
  "This is a simple sv of using a Structural Verilog parser.\n"
  "Usage: %s [OPTIONS] [INPUT_FILE_NAMES]\n"
  "  -o,  --output OUTPUT_FILE_NAME  netlist output file [STDOUT]\n"
  "  -i,  --include INC_FILE_NAMES   coma-separated library input files [STDIN]\n"
  "  -h,  --help                     print this help only\n"
  "  -v,  --version                  print version only\n";
const char* _sv_fmt_version =
  "Version %d.%d\n"
  "Last changed at %s\n"
  "Created by Danil Sokolov (E-mail: danil.sokolov@ncl.ac.uk, ICQ#: 30193190)\n"
  "Copyright (c) 2003, University of Newcastle, Newcastle upon Tyne, UK\n";



const int _sv_version_major = 1;
const int _sv_version_minor = 0;
const char* _sv_version_date = "29 August 2005";

const int _stg_version_major = 1;
const int _stg_version_minor = 0;
const char* _stg_version_date = "07 October 2005";







//---------------------------------------------------------------------------
char* stg_get_help(char* name)
{
  int len = strlen (_stg_fmt_help) + 2 * strlen (name) + 1;
  char* help = new char [len];
  sprintf(help, _stg_fmt_help, name, name);
  return help;
}

//---------------------------------------------------------------------------
char* stg_get_version(char* name)
{
  int len = strlen (_stg_fmt_version) + strlen (_stg_version_date) + 1;
  char* version = new char [len];
  sprintf(version, _stg_fmt_version, _stg_version_major, 
    _stg_version_minor, _stg_version_date);
  return version;
}







//---------------------------------------------------------------------------
char* sv_get_help(char* name)
{
  int len = strlen (_sv_fmt_help) + 2 * strlen (name) + 1;
  char* help = new char [len];
  sprintf (help, _sv_fmt_help, name, name);
  return help;
}

//---------------------------------------------------------------------------
char* sv_get_version (char* name)
{
  int len = strlen (_sv_fmt_version) + strlen (_sv_version_date) + 1;
  char* version = new char [len];
  sprintf (version, _sv_fmt_version, _sv_version_major,
    _sv_version_minor, _sv_version_date);
  return version;
}
