#include "stg_node.h"
#include "stg_place.h"
#include "darray.h"
#include "str_utils.h"

//---------------------------------------------------------------------------
Place::Place(char* name, int marking) : Node(name)
{
  this->setMarking(marking);
  this->preset = new TransitionArray(1);
  this->postset =  new TransitionArray(1);
  this->readset =  new TransitionArray(1);
}

//---------------------------------------------------------------------------
Place::Place(Place& place) : Node(place)
{
  this->setMarking(place.marking);
  this->preset = new TransitionArray(*place.preset);
  this->postset =  new TransitionArray(*place.postset);
  this->readset =  new TransitionArray(*place.readset);
}

//---------------------------------------------------------------------------
Place::~Place()
{
  delete preset;
  delete postset;
  delete readset;
}
