#ifndef _STG_SIGNAL_H_
#define _STG_SIGNAL_H_

#include "darray.h"
#include "hashtable.h"

class Signal;
typedef darray <Signal*> SignalArray;
typedef HashTable <Signal> SignalHashTable;

#include "stg_node.h"

//---------------------------------------------------------------------------
class Signal : public Object
{
  public:
    enum Type 
    { 
      TYPE_UNDEFINED,  
      TYPE_INPUT, 
      TYPE_OUTPUT, 
      TYPE_INTERNAL, 
      TYPE_DUMMY 
    };
    enum State 
    { 
      STATE_UNDEFINED,  
      STATE_HIGH, 
      STATE_LOW 
    };

    Signal(char* name, Type type = TYPE_UNDEFINED, State state = STATE_UNDEFINED);
    Signal(const Signal& signal);

    void setType(Type type);
    Type getType();

    void setState(State state);
    State getState();

  protected:
    Type type;
    State state;
};

//---------------------------------------------------------------------------
inline void Signal::setType(Type type)
{
  this->type = type;
}

//---------------------------------------------------------------------------
inline Signal::Type Signal::getType()
{
  return this->type;
}

//---------------------------------------------------------------------------
inline void Signal::setState(State state)
{
  this->state = state;
}

//---------------------------------------------------------------------------
inline Signal::State Signal::getState()
{
  return this->state;
}

#endif
