#ifndef _SV_CIRCUIT_H_
#define _SV_CIRCUIT_H_

class Circuit;

#include <stdio.h>
#include "sv_object.h"
#include "sv_module.h"
#include "sv_lib.h"

//---------------------------------------------------------------------------
class Circuit : public VerilogObject
{
  protected:
    Lib* lib;
    ModuleHashTable* module_hash_table;
    ModuleArray* modules;
    Module* module_top;

    void clean();
    void findHierarchy(Module* module, int depth);
    int getMaxDepth();

  public:
    Circuit(int tag = TAG_UNDEFINED, char* name = NULL, ModuleArray* modules = NULL, Lib* lib = NULL);
    Circuit(const Circuit &circuit);
    ~Circuit();

    void readModules(char* file_names);
    void writeModules(char* file_name);

    void addModule(Module* module, int position = -1);
    void addModules(ModuleArray* modules);
    void removeModule(Module* module);
    Module* getModule(char* module_name);

    Module* setModuleTop(char* module_name);
    Module* getModuleTop();
    Module* calcModuleTop();

    void calcHierarchy();
    bool isHierarchical();
};

#endif

