#ifndef _SV_INSTANCE_H_
#define _SV_INSTANCE_H_

#include "darray.h"
#include "hashtable.h"

class Instance;
typedef darray <Instance*> InstanceArray;
typedef HashTable <Instance> InstanceHashTable;

#include "sv_object.h"
#include "sv_net.h"
#include "sv_connection.h"
#include "sv_lib.h"

// full name
#define PATTERN_INSTANCE_FULL_NAME        "%s[%d]"
// label name
#define PATTERN_INSTANCE_LABEL            "%s_%d"

//---------------------------------------------------------------------------
class Instance : public VerilogObject
{
  private:
    int index;
    char* module_name;
    Module* container;

    void clean();

  public:
    ConnectionArray* connections;
  //
    Instance(int tag, char* name, int index = -1, char* module_name = NULL, ConnectionArray* connections = NULL);
    Instance(const Instance &instance);
    ~Instance();
    void setIndex(int index);
    int getIndex();
    void setModuleName(char* module_name);
    char* getModuleName();
    void setContainer(Module* container);
    Module* getContainer();
    char* genFullName();
    char* genLabelName();
    void addConnection(Connection* connection, int ind = -1);
    void removeConnection(Connection* connection);
    Connection* getConnection(char* connection_name);
};

#endif

