#ifndef _SV_OBJECT_H_
#define _SV_OBJECT_H_

#include "darray.h"

class VerilogObject;
typedef darray <VerilogObject*> VerilogObjectArray;

#include "object.h"

// port, connection, net properties
#define TAG_PORT_INPUT                    0x00000001
#define TAG_PORT_OUTPUT                   0x00000002
#define TAG_PORT_INOUT                    0x00000003
#define TAG_PORT_WIRE                     0x00000004
#define TAG_PORT_REG                      0x00000008
#define TAG_PORT_                         (TAG_PORT_INPUT | TAG_PORT_OUTPUT | TAG_PORT_INOUT | TAG_PORT_REG | TAG_PORT_WIRE)
// module properties
#define TAG_MODULE_FF                     0x00000800
#define TAG_MODULE_INITIATOR              0x00001000
#define TAG_MODULE_COMPLEX                0x00002000
#define TAG_MODULE_                       (TAG_MODULE_FF | TAG_MODULE_COMPLEX)
// special nets
#define TAG_NET_VDD                       0x04000000
#define TAG_NET_GND                       0x08000000
#define TAG_NET_                          (TAG_NET_VDD | TAG_NET_GND)
// additional tags
#define TAG_OBJ_PROCESSED                 0x10000000
#define TAG_OBJ_HIDDEN                    0x20000000

// print name for escape sequence
#define PATTERN_FULL_NAME_ESCAPE          "%s "
#define SYMBOL_ESCAPE                     '\\'
#define PATTERN_ESCAPE                    "[]()*+-"
// verilog output
#define LINE_LEN_MAX                      256

//---------------------------------------------------------------------------
class VerilogObject : public Object
{
  protected:

    void escapeName();

  public:

    VerilogObject(int tag = TAG_UNDEFINED, char* name = NULL);
    VerilogObject(const VerilogObject& vobject);
    virtual void setName(char* name);
    bool isEscape();
};

#endif

