#ifndef ELEMENT_H
#define ELEMENT_H


#include <iostream.h>
#include "sv_instance.h"




class Element
{
	public:
		//constructor & destructor
		Element();
		Element(Connection *, Instance *);
		Element(const Element &);
		~Element();

		
		//	public accessor methods
		//==========================

		Connection * getConnection() const { return connection; }
		Instance * getInstance() const { return instance; }

		double getDelayTheo() const { return delay_theo; }
		double getDelayPrac() const { return delay_prac; }

		double getDelaySlopeTheo() const { return delay_slope_theo; }
		double getDelaySlopePrac() const { return delay_slope_prac; }

		double getGtheo()	const { return g_theo; }
		double getHtheo()	const { return h_theo; }
		double getPtheo()	const { return p_theo; }

		double getGprac()	const { return g_prac; }
		double getHprac()	const { return h_prac; }
		double getPprac()	const { return p_prac; }

		double getSlopeTheo()	const { return slope_theo; }
		double getSlopePrac()	const { return slope_prac; }
	


    //	public methods
    //==================

		void setConnection(Connection *c) { connection = c; } 
		void setInstance(Instance *post) { instance = post; }

		void setDelayTheo(double delayIn) { delay_theo = delayIn; }
		void setDelayPrac(double delayIn) { delay_prac = delayIn; }

		void setDelaySlopeTheo(double delayIn) { delay_slope_theo = delayIn; }
		void setDelaySlopePrac(double delayIn) { delay_slope_prac = delayIn; }

		void setGtheo(double gIn) { g_theo = gIn; }
		void setHtheo(double hIn) { h_theo = hIn; }
		void setPtheo(double pIn) { p_theo = pIn; }

		void setGprac(double gIn) { g_prac = gIn; }
		void setHprac(double hIn) { h_prac = hIn; }
		void setPprac(double pIn) { p_prac = pIn; }

		void setSlopeTheo(double slopeIn) { slope_theo = slopeIn; }
		void setSlopePrac(double slopeIn) { slope_prac = slopeIn; }



    //overload operators
		friend ostream& operator << (ostream &, const Element &);


		//	public member variables
		//===========================
		
		static double tau;
		

	private:

		//	private methods
		//===================




		
    //	private member variables
		//===========================

		Connection *connection;
		Instance *instance; //successor of connection

		double delay_theo;	//delay using theoretical values
		double delay_prac;	//delay using values from data sheet

		double delay_slope_theo;	//delay using theoretic values for g and h
		double delay_slope_prac;	

		double g_theo;			//logical effort
		double h_theo;			//electrical effort
		double p_theo;			//parasitic delay

		double g_prac;
		double h_prac;
		double p_prac;

		double slope_theo;				//input slope
		double slope_prac;

};

#endif

