#include <stdio.h>
//#include "messages.h"
//#include "str_utils.h"
//#include "stg_net.h"
//#include "sv_circuit.h"
//#include "sv_lib.h"
//#include "sv_module.h"
//#include "le_params.h"

//#include "le_graph.h"
#include "le_leffort.h"


using namespace std;


char * VERILOG_LIB = "verilogLib.v";
char * LE_DELAY = "leDelay.txt";
char * SLOPE_DELAY = "slopeDelay.txt";




int main (int argc, char** argv)
{
	if (argc == 3)
	{		
		LEffort *le = new LEffort;

		le->readVerilog(name2pattern("%s/%s", argv[1],VERILOG_LIB), name2pattern("%s.v",argv[2]));
		le->readParameters(name2pattern("%s/%s",argv[1],LE_DELAY), name2pattern("%s/%s",argv[1],SLOPE_DELAY));
		le->readSTG(name2pattern("%s.g", argv[2]));

		le->extractTraces();
 		le->calculateDelay();

 		le->printTraces();

		char *resultFile = name2pattern("%s.lesta.cvs", argv[2], ".lesta.csv");
		le->printTraces(resultFile);
		delete []resultFile;

		//cout << *le;

		delete le;

	}
	else
	{
		cout << endl << "Usage:" << endl << "	lesta <libPath> <circuit>" << endl;
		cout << "libPath: path to the library files" << endl;
		cout << "circuitName: path to the .v (verilog) file and the .g (STG) file" << endl;
		cout << endl << "Note: the .v and .g files must have the same name but different extensions" << endl;
	}
	return 1;
}


// int main (int argc, char** argv)
// {
// 	char *fileName_lib = NULL;
// 	char *fileName_le = NULL;
// 	char *fileName_xle = NULL;
// 	char *fileName_verilog = NULL;
// 	char *fileName_stg = NULL;
// 
// 
// 	if (argc > 1)
//   {
// 		for (int i=1; i<argc-1 ; i++)
// 		{
// 			char par_lib[] = "-lib=";
// 			char par_le[] = "-le=";
// 			char par_xle[] = "-xle=";
// 			char par_verilog[] = "-verilog=";
// 			char par_stg[] = "-stg=";
// 
// 
// 			if (strncmp(par_lib, argv[i], strlen(par_lib)) == 0) //-lib=fileName
// 				fileName_lib = argv[i][strlen(par_lib);
// 			else if (strncmp(par_le, argv[i], strlen(par_le)) == 0) //-le=fileName
// 				fileName_le = argv[i][strlen(par_le)];
// 			else if (strncmp(par_xle, argv[i], strlen(par_xle)) == 0) //-xle=fileName
// 				fileName_xle = argv[i][strlen(par_xle)];
// 			else if (strncmp(par_verilog, argv[i], strlen(par_verilog)) == 0) //-verilog=fileName
// 				fileName_verilog = argv[i][strlen(par_verilog)];
// 			else if (strncmp(par_stg, argv[i], strlen(stg)) == 0) //-stg=fileName
// 				fileName_stg = argv[i][strlen(stg)];
// 			//else
// 				//printHelp();
// 		}
// 		if ((fileName_lib == NULL) || (fileName_le == NULL) || (fileName_verilog == NULL) || (fileName_stg == NULL))
// 		{
// 			//printHelp();
// 			return 1;
// 		}
// 	}
// 	else
// 	{
// 		return 1;
// 		//printHelp();
// 	}
// 
// 	LEffort *le = new LEffort;
// 
// 	le->readVerilog(fileName_lib, fileName_verilog);
// 	le->readParameters(fileName_le, fileName_xle);
// 	le->readSTG(fileName_stg);
// 
// 	le->extractTraces();
// 	le->calculateDelay();
// 
// 	le->printTraces();
// 
// 	char *resultFile = name2pattern("%s%s", fileName_stg, ".le.csv");
// 	le->printTraces(resultFile);
// 	delete []resultFile;
// 
// 	//cout << *le;
// 
// 	delete le;
// 
// 
// 	return 1;
// }
// 




