#include "le_path.h"


//constructor
Path::Path()
{
	path = NULL;

	delay_theo = 0.0;
	delay_prac = 0.0;

	delay_slope_theo = 0.0;
	delay_slope_prac = 0.0;
}




Path::Path(const Path &rhs)
{

	if (rhs.path != NULL)
	{
		path = new darray<Element*>(rhs.path->num);
		for (int i=0; i<rhs.path->num; i++)
			path->add(new Element(*(rhs.path->arr[i])));

	}
	else
		path = NULL;

	delay_theo = rhs.delay_theo;
	delay_prac = rhs.delay_prac;

	delay_slope_theo = rhs.delay_slope_theo;
	delay_slope_prac = rhs.delay_slope_prac;
}



//destructor
Path::~Path()
{
	if (path != NULL)
	{
		for (int i=0; i<path->num; i++)
			delete path->arr[i];
		delete path;
	}
}




void Path::set(Element *e)
{	
	if (path == NULL)
		path = new darray<Element*>();

	path->add(e);

}




void Path::set(Connection *c, Instance *i)
{	
	if (path == NULL)
		path = new darray<Element*>();

	Element *element = new Element(c, i);
	path->add(element);

}






int Path::compare(const void *a, const void *b)
{
	double delay_a = (**(Path**)a).getDelayTheo();
	double delay_b = (**(Path**)b).getDelayTheo();

	if (delay_a > delay_b)
		return -1;
	else if (delay_a < delay_b)
		return 1;
	else
		return 0;
}






//####################################################################################
//overload operators
//####################################################################################

ostream& operator << (ostream &os, const Path &p)
{
	cout.precision(3);

	if (p.getPath() != NULL)
	{
		for (int i=0; i<p.getPath()->num; i++)
		{
			cout << *(p.getPath()->arr[i]);
			if (i < (p.getPath()->num-1))
				cout << " -> ";
		}
		cout << endl;
		

		cout << " " << p.getDelayTheo() << " = ";
		for (int i=0; i<p.getPath()->num-1; i++)
		{
			cout << p.getPath()->arr[i]->getDelayTheo();
			if (i < (p.getPath()->num-2))
				cout << " + ";
		}
		cout << " (delay_theo)" << endl;

// 		cout << "      = ";
// 		for (int i=0; i<p.getPath()->num-1; i++)
// 		{
// 			cout << Element::tau << "(" << p.getPath()->arr[i]->getGtheo() << "*" << p.getPath()->arr[i]->getHtheo() << " + " << p.getPath()->arr[i]->getPtheo() << ")";
// 			if (i < (p.getPath()->num-2))
// 				cout << " + ";
// 		}
// 		cout << endl;
		

// 		cout << " " << p.getDelayPrac() << " = ";
// 		for (int i=0; i<p.getPath()->num-1; i++)
// 		{
// 			cout << p.getPath()->arr[i]->getDelayPrac();
// 			if (i < (p.getPath()->num-2))
// 				cout << " + ";
// 		}
// 		cout << " (delay_prac)" << endl;
// 	
// 		cout << "      = ";
// 		for (int i=0; i<p.getPath()->num-1; i++)
// 		{
// 			cout << "(" << p.getPath()->arr[i]->getGprac() << "*" << p.getPath()->arr[i]->getHprac() << " + " << p.getPath()->arr[i]->getPprac() << ")";
// 			if (i < (p.getPath()->num-2))
// 				cout << " + ";
// 		}
// 		cout << endl;
// 
// 		cout << " " << p.getDelayTheo() / p.getDelayPrac() << " (delay_theo / delay_prac)" << endl;
	}

	return os;
}









///////////////////////////////////////////////////////////////////////////////////////
//	private methods
///////////////////////////////////////////////////////////////////////////////////////






