#ifndef PATH_H
#define PATH_H


#include "darray.h"
#include "le_element.h"



class Path
{
	public:
		//constructor & destructor
		Path();
		Path(const Path &);
		~Path();

		
		//	public accessor methods
		//==========================

		darray<Element*> * getPath() const { return path; }

		double getDelayTheo() const { return delay_theo; }
		double getDelayPrac() const { return delay_prac; }

		double getDelaySlopeTheo() const { return delay_slope_theo; }
		double getDelaySlopePrac() const { return delay_slope_prac; }
		
    //	public methods
    //==================

		void set(Element *);
		void set(Connection *, Instance *);

		void setDelayTheo(double delayIn) { delay_theo = delayIn; }
		void setDelayPrac(double delayIn) { delay_prac = delayIn; }

		void setDelaySlopeTheo(double delayIn) { delay_slope_theo = delayIn; }
		void setDelaySlopePrac(double delayIn) { delay_slope_prac = delayIn; }


		static int compare(const void *, const void *);


    //overload operators
		friend ostream& operator << (ostream &, const Path &);


		//	public member variables
		//===========================
		

		

	private:

		//	private methods
		//===================




		
    //	private member variables
		//===========================

		darray<Element*> *path;

		double delay_theo;
		double delay_prac;
		double delay_slope_theo;
		double delay_slope_prac;
    
};

#endif

