#include "le_trace.h"


//constructor
Trace::Trace()
{
	transitions = NULL;
	connections = NULL;
	paths = NULL;
}





Trace::Trace(const Trace &rhs)
{
	if (rhs.transitions != NULL)
	{
		transitions = new darray<Transition*>(rhs.transitions->num);
		for (int i=0; i<rhs.transitions->num; i++)
			transitions->add(rhs.transitions->arr[i]);

	}
	else
		transitions = NULL;

	if (rhs.connections != NULL)
	{
		connections = new darray<Connection*>(rhs.connections->num);
		for (int i=0; i<rhs.connections->num; i++)
			connections->add(rhs.connections->arr[i]);

	}
	else
		connections = NULL;

	paths = NULL;
}



//destructor
Trace::~Trace()
{
	if (transitions != NULL)
		delete transitions;
	transitions = NULL;

	if (connections != NULL)
		delete connections;
	connections = NULL;
	
	if (paths != NULL)
	{
		for (int i=0; i<paths->num; i++)
			delete paths->arr[i];
		delete paths;
		paths = NULL;
	}
}


void Trace::set(Transition *t)
{
	if (transitions == NULL)
		transitions = new darray<Transition*>();

	transitions->add(t);
}




void Trace::set(Connection *c)
{	
	if (c == NULL)
		return;

	if (connections == NULL)
		connections = new darray<Connection*>();

	connections->add(c);
}



void Trace::set(Path *p)
{
	if (paths == NULL)
		paths = new darray<Path *>();

	paths->add(new Path(*p)); 
}




int Trace::compare(const void *a, const void *b)
{
	double delay_a = 0.0;
	double delay_b = 0.0;


	if ((**(Trace**)a).getPaths() != NULL)
		delay_a = (**(Trace**)a).getPaths()->arr[0]->getDelayTheo();
	if ((**(Trace**)b).getPaths() != NULL)
		delay_b = (**(Trace**)b).getPaths()->arr[0]->getDelayTheo();


	if (delay_a > delay_b)
		return -1;
	else if (delay_a < delay_b)
		return 1;
	else
		return 0;
}




//####################################################################################
//overload operators
//####################################################################################


ostream& operator << (ostream &os, const Trace &t)
{
	if (t.getTransitions() != NULL)
	{
		for (int i=0; i<t.getTransitions()->num; i++)
		{
			bool isInOutput = true;
			if ((t.getTransitions()->arr[i]->getSignal()->getType() == Signal::TYPE_INPUT) || (t.getTransitions()->arr[i]->getSignal()->getType() == Signal::TYPE_OUTPUT))
				isInOutput = false;
			if (isInOutput) cout << "(";
			cout << t.getTransitions()->arr[i]->getName();
			if (isInOutput) cout << ")";
			if (i < (t.getTransitions()->num-1))
				cout << ", ";
		}
		cout << endl;
	}

// 	if (t.getConnections() != NULL)
// 	{
// 		for (int i=0; i<t.getConnections()->num; i++)
// 		{
// 			cout << t.getConnections()->arr[i]->genFullName();
// 			if (i < (t.getConnections()->num-1))
// 				cout << ", ";
// 		}
// 		cout << endl;
// 	}

	if (t.getPaths() != NULL)
		for (int i=0; i<t.getPaths()->num; i++)
		{
			cout << "path " << i+1 << ": ";
			cout << *(t.getPaths()->arr[i]);
		}

	return os;
}









///////////////////////////////////////////////////////////////////////////////////////
//	private methods
///////////////////////////////////////////////////////////////////////////////////////






