%{
#include <stdio.h>
#include <string.h>
#include "str_utils.h"
#include "parameter_y.h"
%}

%option yylineno

WS        [\t\n\r\ ]
BEGIN			begin
END				end
DIGIT			[0-9]
NUM1 			{DIGIT}+
NUM2 			{DIGIT}*\.{DIGIT}+
NUM	 			{NUM1}|{NUM2}
ID   	    [a-zA-Z][a-zA-Z0-9]*


%%




{WS} 		{ /*skip white spaces*/ }

"//"[^\n]*\n	{ /* eat up one-line C++ comments */ }

"["		{ return ('['); }

"]"		{ return (']'); }


"."		{ return ('.'); } 


{BEGIN}	{
         	return YYBEGIN;
        }

{END}	{
				return YYEND;
			}

{NUM}  {
  			parameter_lval.value = atof(yytext);
  			return YYNUM;
		}

{ID}	{
      	//parameter_lval.name = (char*)malloc(sizeof(char)*(strlen(yytext)+1));
        //strcpy(parameter_lval.name, yytext);
				parameter_lval.name = namecopy(yytext);
        return YYID;
     	}

<<EOF>>	{
					// Free the buffer which remains un-freed due to a flex bug
					yy_delete_buffer(yy_current_buffer);
     			yy_init = 1;

        	yyterminate();
        }
		
%%
int yywrap()
{
    return 1;
}




