#ifndef _STG_PLACE_H_
#define _STG_PLACE_H_

#include "darray.h"
#include "hashtable.h"

class Place;
typedef darray <Place*> PlaceArray;
typedef HashTable <Place> PlaceHashTable;

#include "stg_node.h"
#include "stg_transition.h"

//---------------------------------------------------------------------------
class Place : public Node
{
  public:
    TransitionArray* preset;
    TransitionArray* postset;
    TransitionArray* readset;

    Place(char* name, int marking = 0);
    Place(Place& place);
    ~Place();

    void setMarking(int marking);
    int getMarking();
    
    bool isImplicit();

  protected:
    int marking;
};

//---------------------------------------------------------------------------
inline void Place::setMarking(int marking)
{
  this->marking = marking;
}

//---------------------------------------------------------------------------
inline int Place::getMarking()
{
  return this->marking;
}

#endif
